<?php defined('_JEXEC') or die();
/**
 * @version		1.1.0
 * @package		rsiFAQ
 * @subpackage	Component
 * @copyright	Copyright (C) 2010 Rockford Solutions, Inc. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

jimport('joomla.application.component.controller');

class rsiFAQController extends JController {
	protected $_resource = null;
	protected $_baseurl  = null;
	protected $_listurl  = null;
	protected $_formurl  = null;
	protected $_moveurl  = null;
	
	public function __construct($resource = null) {
		parent::__construct();
		
		global $option;
		
		$this->_resource = $resource;
		$this->_baseurl  = 'index.php?option=' . $option . '&view=' . $resource;
		$this->_listurl  = $this->_baseurl;
		$this->_formurl  = $this->_baseurl . '&layout=form';
		$this->_moveurl  = $this->_baseurl . '&layout=move';
		
		$this->registerTask('add', 'edit');
	}
	
	public function display() {
		$view = JRequest::getString('view', 'about');
		JRequest::setVar('view', $view);
		
		parent::display();
	}
	
	public function edit() {
		JRequest::setVar('view', $this->_resource);
		JRequest::setVar('layout', 'form');
		JRequest::setVar('hidemainmenu', 1);
		
		parent::display();
	}
	
	public function save() {
		$model =& $this->getModel($this->_resource);
		$row = $model->store();
		
		$this->setRedirect($this->_listurl);
	}
	
	public function apply() {
		$model =& $this->getModel($this->_resource);
		$row = $model->store();
		
		$this->setRedirect($this->_formurl . '&cid[]=' . $row->id);
	}
	
	public function remove() {
		$model =& $this->getModel($this->_resource);
		$model->delete();
		
		$this->setRedirect($this->_listurl);
	}
	
	public function cancel() {
		$msg = 'Operation Cancelled';
		$this->setRedirect($this->_listurl, $msg);
	}
	
	public function saveorder() {
		$model =& $this->getModel($this->_resource);
		$model->saveorder();
		
		$this->setRedirect($this->_listurl);
	}
	
	public function orderup() {
		$model =& $this->getModel($this->_resource);
		$model->orderup();
		
		$this->setRedirect($this->_listurl);
	}
	
	public function orderdown() {
		$model =& $this->getModel($this->_resource);
		$model->orderdown();
		
		$this->setRedirect($this->_listurl);
	}
	
	public function move() {
		$pid = JRequest::getVar('pid', array(), null, 'array');
		
		if (empty($pid)) {
			JRequest::setVar('view', $this->_resource);
			JRequest::setVar('layout', 'move');
			JRequest::setVar('hidemainmenu', 1);
			
			parent::display();
		} else {
		var_dump($this->_resource);
			$model =& $this->getModel($this->_resource);
			$model->move();
			
			$this->setRedirect($this->_listurl);
		}
	}
	
	public function publish() {
		$model =& $this->getModel($this->_resource);
		$model->publish();
		
		$this->setRedirect($this->_listurl);
	}
	
	public function unpublish() {
		$model =& $this->getModel($this->_resource);
		$model->unpublish();
		
		$this->setRedirect($this->_listurl);
	}
	
	public function accesspublic() {
		$model =& $this->getModel($this->_resource);
		$model->accesspublic();
		
		$this->setRedirect($this->_listurl);
	}
	
	public function accessregistered() {
		$model =& $this->getModel($this->_resource);
		$model->accessregistered();
		
		$this->setRedirect($this->_listurl);
	}
	
	public function accessspecial() {
		$model =& $this->getModel($this->_resource);
		$model->accessspecial();
		
		$this->setRedirect($this->_listurl);
	}
}
