<?php defined('_JEXEC') or die();
/**
 * @version		1.1.0
 * @package		rsiFAQ
 * @subpackage	Component
 * @copyright	Copyright (C) 2010 Rockford Solutions, Inc. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

class rsiFAQModelSections extends rsiFAQModel {
	public function __construct() {
		parent::__construct('sections', 'section');
	}
	
	protected function _buildQuery() {
		$query = 'SELECT `sections`.*, '
		       . 'COUNT(`categories`.`id`) AS `categories`, '
		       . 'COUNT(`questions`.`id`) AS `questions` '
		       . 'FROM `#__rsi_faq_sections` AS `sections` '
			   . 'LEFT JOIN `#__rsi_faq_categories` AS `categories` '
			   . 'ON `sections`.`id` = `categories`.`section_id` '
			   . 'LEFT JOIN `#__rsi_faq_questions` AS `questions` '
			   . 'ON `categories`.`id` = `questions`.`category_id` '
			   . $this->_buildQueryWhere() . ' '
			   . 'GROUP BY `sections`.`id` '
			   . $this->_buildQueryOrderBy();
			   //$this->_db->setQuery($query); echo '<div>' . $this->_db->getQuery() . '</div>';
		
		return $query;
	}
	
	protected function _buildQueryWhere() {
		$search = $this->getState('filter_search');
		$status = $this->getState('filter_status');
		
		$where = array();
		
		if ($search !== '') {
			$keywords = explode(' ', trim($search));
			
			$ids    = array();
			$titles = array();
			
			foreach ($keywords as $keyword) {
				if ($keyword !== '') {
					$ids[]    = '`sections`.`id` LIKE \'%' . $keyword . '%\'';
					$titles[] = '`sections`.`title` LIKE \'%' . $keyword . '%\'';
				}
			}
			
			$where[] = '(' . implode(' OR ', $ids) . ' OR ' . implode(' OR ', $titles) . ')';
		}
		
		if ($status !== '') {
			$where[] = '`sections`.`status` = ' . (int) $status;
		}
		
		return empty($where) ? '' : 'WHERE ' . implode(' AND ', $where);
	}
	
	protected function _buildQueryOrderBy() {
		$order = $this->getState('filter_order');
		$dir   = $this->getState('filter_dir');
		
		return 'ORDER BY `sections`.`' . $order . '` ' . $dir;
	}
}
