<?php defined('_JEXEC') or die();
/**
 * @version		1.1.0
 * @package		rsiFAQ
 * @subpackage	Component
 * @copyright	Copyright (C) 2010 Rockford Solutions, Inc. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

jimport('joomla.application.component.view');

abstract class rsiFAQView extends JView {
	public function display($tmpl = null) {
		global $option;
		
		JHTML::_('behavior.mootools');
		
		$document =& JFactory::getDocument();
		$document->addStylesheet('components/' . $option . '/css/component.css');
		
		JToolBarHelper::title('rsiFAQ', 'faq');
		JToolBarHelper::preferences($option, 450);
		
		parent::display($tmpl);
		
		echo '<div class="rsi-poweredby">powered by '
		   . '<a href="http://www.rockfordsolutionsinc.com/" target="_blank">Rockford Solutions, Inc</a>'
		   . '</div>';
	}
	
	public function checked(&$row, $i) {
		$checked = '<input type="checkbox" id="cb' . $i . '" '
		         . 'name="cid[]" value="' . ($row->id) . '" '
				 . 'onclick="isChecked(this.checked);" />';
		
		return $checked;
	}
	
	public function status(&$row, $i) {
		$image = $row->status ? 'tick.png' : 'publish_x.png';
		$task  = $row->status ? 'unpublish' : 'publish';
		$alt   = $row->status ? JText::_('Published') : JText::_('Unpublished');
		$title = $row->status ? JText::_('Unpublish Item') : JText::_('Publish item');
		
		$status = '<a href="javascript:void(0);" title="' . $title . '" '
		        . 'onclick="return listItemTask(\'cb' . $i . '\', \'' . $task .'\')">'
		        . '<img src="images/' . $image . '" border="0" alt="' . $alt . '" /></a>';
		
		return $status;
	}
	
	public function access(&$row, $i) {
		if ($row->access == 0) {
			$label = 'Public';
			$color = 'green';
			$task  = 'accessregistered';
		} elseif ($row->access == 1) {
			$label = 'Registered';
			$color = 'red';
			$task  = 'accessspecial';
		} else {
			$label = 'Special';
			$color = 'black';
			$task  = 'accesspublic';
		}
		
		$access = '<a href="javascript:void(0);" style="color: ' . $color . ';" '
		        . 'onclick="return listItemTask(\'cb'. $i .'\', \''. $task .'\');">' . $label . '</a>';
		
		return $access;
	}
}
