<?php defined('_JEXEC') or die();
/**
 * @version		1.1.0
 * @package		rsiFAQ
 * @subpackage	Component
 * @copyright	Copyright (C) 2010 Rockford Solutions, Inc. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

class rsiFAQViewQuestions extends rsiFAQView {
	public function display($tmpl = null) {
		switch (JRequest::getVar('layout')) {
			case 'form':
				JToolbarHelper::save();
				JToolbarHelper::apply();
				
				if (JRequest::getVar('task') == 'edit') {
					JToolbarHelper::cancel('cancel', 'Close');
				} else {
					JToolbarHelper::cancel();
				}
				
				$row        = $this->get('row');
				$order      = $this->get('order');
				$sections   = $this->get('sections');
				$categories = $this->get('categories');
				$opts       = array();
				
				$this->assignRef('row',   $row);
				$this->assignRef('opts',  $opts);
				$this->assignRef('order', $order);
				
				foreach ($sections as $section) {
					$opts[] = JHTML::_('select.optgroup', $section->title, 'id', 'title');
					foreach ($categories as $category) {
						if ($section->id == $category->section_id) {
							$opts[] = JHTML::_('select.option', $category->id, $category->title, 'id', 'title');
						}
					}
				}
				
			break;
			case 'move':
				JToolBarHelper::custom('move', 'move', '', 'Move', false, false);
				JToolbarHelper::cancel();
				
				$rows       = $this->get('selected');
				$sections   = $this->get('sections');
				$categories = $this->get('categories');
				$opts       = array();
				
				$this->assignRef('rows', $rows);
				$this->assignRef('opts', $opts);
				
				foreach ($sections as $section) {
					$opts[] = JHTML::_('select.optgroup', $section->title, 'id', 'title');
					foreach ($categories as $category) {
						if ($section->id == $category->section_id) {
							$opts[] = JHTML::_('select.option', $category->id, $category->title, 'id', 'title');
						}
					}
				}
			break;
			default:
				JToolBarHelper::publishList();
				JToolBarHelper::unpublishList();
				JToolBarHelper::custom('move', 'move', '', 'Move', true, true);
				JToolBarHelper::deleteList();
				JToolBarHelper::editListX();
				JToolBarHelper::addNewX();
			
				$rows  = $this->get('rows');
				$pages = $this->get('pages');
				$state = $this->get('state');
				
				$lists = array(
					'search'      => $state->get('filter_search'),
					'status'      => $state->get('filter_status'),
					'order'       => $state->get('filter_order'),
					'dir'         => $state->get('filter_dir'),
					'section_id'  => $state->get('filter_section_id'),
					'category_id' => $state->get('filter_category_id')
				);
				
				$this->assignRef('rows',  $rows);
				$this->assignRef('pages', $pages);
				$this->assignRef('lists', $lists);
				
				$sections   = $this->get('sections');
				$categories = $this->get('categories');
				
				$this->assignRef('sections',   $sections);
				$this->assignRef('categories', $categories);
			break;
		}
		
		parent::display($tmpl);
	}
}
