<?php
/**
* @Copyright Copyright (C) 2010 VTEM . All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* @link     	http://www.vtem.net
**/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

class vtemgalleryControllercategory extends JController
{
	/**
	 * Constructor
	 */
	function __construct( $config = array() )
	{
		parent::__construct( $config );
		// Register Extra tasks
		$this->registerTask( 'add',			'edit' );
		$this->registerTask( 'add',			'edit' );
		$this->registerTask( 'apply',		'save' );
		$this->registerTask( 'resethits',	'save' );
		$this->registerTask( 'unpublish',	'publish' );
	}
 	
	/**
	 * Display the list of banners
	 */
	function display()
	{
		global $mainframe;

		$db =& JFactory::getDBO();

		$context			= 'com_vtemgallery.vtemgallerycategory.list.';
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order',		'filter_order',		'b.category',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir',	'filter_order_Dir',	'',			'word' );
		$filter_catid		= $mainframe->getUserStateFromRequest( $context.'filter_catid',		'filter_catid',		'',			'int' );
		$filter_state		= $mainframe->getUserStateFromRequest( $context.'filter_state',		'filter_state',		'',			'word' );
		$search				= $mainframe->getUserStateFromRequest( $context.'search',			'search',			'',			'string' );

		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $context.'limitstart', 'limitstart', 0, 'int' );

		$where = array();
  		
		if ( $filter_state )
		{
			if ( $filter_state == 'P' ) {
				$where[] = 'b.published = 1';
			}
			else if ($filter_state == 'U' ) {
				$where[] = 'b.published = 0';
			}
		}

		if ($search) {
			$where[] = 'LOWER(b.category) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}

		$where		= count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '';
		$orderby	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', b.category';

		// get the total number of records
		$query = 'SELECT COUNT(*)'
		. ' FROM #__vtemgallery_category AS b'
		. $where
		;
		$db->setQuery( $query );
		$total = $db->loadResult();

		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );

		$query = 'SELECT b.*, u.name AS editor, user.name AS postedname'
		. ' FROM #__vtemgallery_category AS b'
		. ' LEFT JOIN #__users AS u ON u.id = b.checked_out'
		. ' JOIN #__users AS user ON user.id = b.createdby'
 		. $where
		. $orderby
		;
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();

		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );

		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;

		// search filter
		$lists['search']= $search;

		require_once(JPATH_COMPONENT.DS.'views'.DS.'category.php');
		vtemgalleryViewCategory::vtemgalleryCategory( $rows, $pageNav, $lists );
	}
	
	function edit()
	{
		$db		=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		
		if ($this->_task == 'edit') {
			$cid	= JRequest::getVar('cid', '', 'method', 'array');
			$cid	= array((int) $cid[0]);
		} else {
			$cid	= array( 0 );
		}

		$option = JRequest::getCmd('option');

		$lists = array();

		$row =& JTable::getInstance('category', 'Table');

		$row->load( $cid[0] );
 		if ($cid[0]) {
			$row->checkout( $user->get('id') );
		} else {
			$row->published = 1;
		}
 		// Build Category select list
		$sql = 'SELECT * '
		. ' FROM #__vtemgallery_category WHERE id = '.$cid[0];
		$db->setQuery($sql);
		if (!$db->query())
		{
			$this->setRedirect( 'index.php?option=com_vtemgallery&c=category' );
			return JError::raiseWarning( 500, $db->getErrorMsg() );
		}

		require_once(JPATH_COMPONENT.DS.'views'.DS.'category.php');
		vtemgalleryViewCategory::editCategory( $row, $lists );
	}

	/**
	 * Save method
	 */
	function save()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$user =& JFactory::getUser();
		
		$this->setRedirect( 'index.php?option=com_vtemgallery&c=category' );
		
		$id	= JRequest::getVar('id', '', 'post', 'int');
		$category	= JRequest::getVar('category', '', 'post', 'string');
		if(trim($category) == ''){
			$msg = JText::_( '&nbsp; Please enter image title.' );
			$link = JRoute::_('index.php?option=com_vtemgallery', false);
			$this->setRedirect( $link, $msg );  return;
		}
		
		// Initialize variables
		$db =& JFactory::getDBO();

		$post	= JRequest::get( 'post' );
 		
		if($id<=0){
 			$post["createdby"] =  $user->get('id');
			$createdon =& JFactory::getDate();
			$post["createdon"] =  $createdon->toMySQL();
		}
		$updatedon =& JFactory::getDate();
		$post["updatedon"] =  $updatedon->toMySQL();
		$post["updatedby"] =  $user->get('id');

		$row =& JTable::getInstance('category', 'Table');
  
		if (!$row->bind( $post )) {
			return JError::raiseWarning( 500, $row->getError() );
		}

		// Resets clicks when `Reset Clicks` button is used instead of `Save` button
		$task = JRequest::getCmd( 'task' );
 
		if (!$row->check()) {
			return JError::raiseWarning( 500, $row->getError() );
		}

 		if (!$row->store()) {
			return JError::raiseWarning( 500, $row->getError() );
		}
		$row->checkin();

		switch ($task)
		{
			case 'apply':
				$link = 'index.php?option=com_vtemgallery&c=category&task=edit&cid[]='. $row->id ;
				break;

			case 'save':
			default:
				$link = 'index.php?option=com_vtemgallery&c=category&id='.$id;
				break;
		}

		$this->setRedirect( $link, JText::_( 'Item Saved' ) );
	}

	function cancel()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$pid	= JRequest::getVar('pid', '', 'post', 'int');
		$this->setRedirect( 'index.php?option=com_vtemgallery');

		// Initialize variables
		$db		=& JFactory::getDBO();
		$post	= JRequest::get( 'post' );
		$row	=& JTable::getInstance('category', 'Table');
		$row->bind( $post );
		$row->checkin();
	}

	 
	function publish()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
 		$this->setRedirect( 'index.php?option=com_vtemgallery');
 
 		// Initialize variables
		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$task		= JRequest::getCmd( 'task' );
		$publish	= ($task == 'publish');
		$n			= count( $cid );

		if (empty( $cid )) {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}

		JArrayHelper::toInteger( $cid );
		$cids = implode( ',', $cid );

		$query = 'UPDATE #__vtemgallery_category'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '. $cids.'  )'
		. ' AND ( checked_out = 0 OR ( checked_out = ' .(int) $user->get('id'). ' ) )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			return JError::raiseWarning( 500, $db->getError() );
		}
		$this->setMessage( JText::sprintf( $publish ? 'Items published' : 'Items unpublished', $n ) );
	}

	function remove()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$base = "../administrator/components/com_vtemgallery/";
		$working_folder =$base."vtemgallery/";
		
 		$this->setRedirect( 'index.php?option=com_vtemgallery');
  		// Initialize variables
		$db		=& JFactory::getDBO();
		$pid	= JRequest::getVar('pid', '', 'post', 'int');

		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$n		= count( $cid );
		JArrayHelper::toInteger( $cid );

		if ($n)
		{
			for($i=0; $i < $n; $i++){ 
				$query = "SELECT image FROM #__vtemgallery_images WHERE category_id = ".$cid[$i];
				$db->setQuery( $query );
				$rows = $db->loadObjectList();
				if (file_exists($working_folder."th".$rows[0]->image)) 
				{ 
					@unlink($working_folder."th".$rows[0]->image);
				}
				@unlink($working_folder.$rows[0]->image);
 			}
			$query = 'DELETE FROM #__vtemgallery_images'
			. ' WHERE category_id = ' . implode( ' OR category_id = ', $cid );
			$db->setQuery( $query );
			if (!$db->query()) {
				JError::raiseWarning( 500, $db->getError() );
			}
			
 			$query = 'DELETE FROM #__vtemgallery_category'
			. ' WHERE id = ' . implode( ' OR id = ', $cid );
			$db->setQuery( $query );
			if (!$db->query()) {
				JError::raiseWarning( 500, $db->getError() );
			} 
 		}
 		$this->setMessage( JText::sprintf( 'Items removed', $n ) );
	}
	
 	/**
	 * function for Get total Comments
	 **/
	function fncGetTotalImages( $options=array() )
	{
		$db 		=& JFactory::getDBO();
		$id			= @$options['id'];
		
		// WHere conditions
		$wheres[] = 'images.category_id = ' . (int) $id;
		
		$db		=& JFactory::getDBO();				
		$query	= 	'SELECT COUNT(images.category_id)
					FROM #__vtemgallery_images AS images JOIN #__vtemgallery_category AS cat ON images.category_id = cat.id
					WHERE '. implode( ' AND ', $wheres );
 		$db->setQuery( $query );
		$count = $db->loadResult();
		return (int)$count;
	}

 }
?>