<?php defined('_JEXEC') or die();
/**
 * @version		1.1.0
 * @package		rsiFAQ
 * @subpackage	Component
 * @copyright	Copyright (C) 2010 Rockford Solutions, Inc. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

class rsiFAQModelCategory extends rsiFAQModel {
	public function getSection() {
		$id   =  JRequest::getInt('id', 0);
		$user =& JFactory::getUser();
		
		$query = 'SELECT `sections`.* '
		       . 'FROM `#__rsi_faq_sections` AS `sections` '
			   . 'INNER JOIN `#__rsi_faq_categories` AS `categories` '
			   . 'ON `sections`.`id` = `categories`.`section_id` '
			   . 'WHERE `sections`.`status` = 1 '
			   . 'AND `sections`.`access` <= ' . $user->get('aid') . ' '
			   . 'AND `categories`.`status` = 1 '
			   . 'AND `categories`.`access` <= ' . $user->get('aid') . ' '
			   . 'AND `categories`.`id` = ' . (int) $id . ' ';
		
		return $this->_getObject($query);
	}
	
	public function getCategory() {
		$id   =  JRequest::getInt('id', 0);
		$user =& JFactory::getUser();
		
		$query = 'SELECT `categories`.* '
		       . 'FROM `#__rsi_faq_sections` AS `sections` '
			   . 'INNER JOIN `#__rsi_faq_categories` AS `categories` '
			   . 'ON `sections`.`id` = `categories`.`section_id` '
			   . 'WHERE `sections`.`status` = 1 '
			   . 'AND `sections`.`access` <= ' . $user->get('aid') . ' '
			   . 'AND `categories`.`status` = 1 '
			   . 'AND `categories`.`access` <= ' . $user->get('aid') . ' '
			   . 'AND `categories`.`id` = ' . (int) $id . ' ';
		
		return $this->_getObject($query);
	}
	
	public function getQuestions() {
		$id   =  JRequest::getInt('id', 0);
		$user =& JFactory::getUser();
		
		$query = 'SELECT `questions`.*, '
		       . '`authors`.`id` AS `author_id`, `authors`.`name` AS `author_name`, '
		       . '`editors`.`id` AS `editor_id`, `editors`.`name` AS `editor_name` '
		       . 'FROM `#__rsi_faq_sections` AS `sections` '
			   . 'INNER JOIN `#__rsi_faq_categories` AS `categories` '
			   . 'ON `sections`.`id` = `categories`.`section_id` '
			   . 'LEFT JOIN `#__rsi_faq_questions` AS `questions` '
			   . 'ON `categories`.`id` = `questions`.`category_id` '
			   . 'LEFT JOIN `#__users` AS `authors` '
			   . 'ON `questions`.`author_id` = `authors`.`id` '
			   . 'LEFT JOIN `#__users` AS `editors` '
			   . 'ON `questions`.`editor_id` = `editors`.`id` '
			   . 'WHERE `sections`.`status` = 1 '
			   . 'AND `sections`.`access` <= ' . $user->get('aid') . ' '
			   . 'AND `categories`.`status` = 1 '
			   . 'AND `categories`.`access` <= ' . $user->get('aid') . ' '
			   . 'AND `categories`.`id` = ' . (int) $id . ' '
			   . 'AND `questions`.`status` = 1 '
			   . 'AND `questions`.`access` <= ' . $user->get('aid') . ' '
			   . 'ORDER BY `questions`.`order`';
		
		return $this->_getList($query);
	}
}
