<?php defined('_JEXEC') or die();
/**
 * @version		1.1.0
 * @package		rsiFAQ
 * @subpackage	Component
 * @copyright	Copyright (C) 2010 Rockford Solutions, Inc. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

global $option;
?>
 
<div class="componentheading"><?php echo $this->category->title; ?></div>
<ol id="qlist">
	<?php foreach ($this->questions as $question) { ?>
	<li><a href="#q<?php echo $question->id; ?>"><?php echo $question->question; ?></a></li>
	<?php } ?>
	<?php if ($this->params->get('allow_frontend_questions')) { ?>
	<li><a href="#qnew"><?php echo $this->params->get('frontend_form_title'); ?></a></li>
	<?php } ?>
</ol>
<?php foreach ($this->questions as $question) { ?>
<div id="q<?php echo $question->id; ?>" class="qblock">
	<div class="contentheading"><?php echo JText::_('Question'); ?>: <?php echo $question->question; ?></div>
	<?php if ($this->params->get('show_editor_name') && !empty($question->editor_name)) { ?>
	<div class="small"><?php echo JText::_('WRITTEN BY') . ' ' . $question->editor_name; ?></div>
	<?php } ?>
	<?php if ($this->params->get('show_created_date')) { ?>
	<div class="createdate"><?php echo JHTML::_('date', $question->created, JText::_('DATE_FORMAT_LC2')); ?></div>
	<?php } ?>
	<p><?php echo JText::_('Answer'); ?>: <?php echo nl2br($question->answer); ?></p>
	<?php if ($this->params->get('show_updated_date') && $question->updated > $question->created) { ?>
	<div class="modifydate"><?php echo JText::sprintf('LAST_UPDATED2', JHTML::_('date', $question->updated, JText::_('DATE_FORMAT_LC2'))); ?></div>
	<?php } ?>
	<div><a href="#qlist"><?php echo JText::_('Back to Top'); ?></a></div>
</div>
<?php } ?>
<?php if ($this->params->get('allow_frontend_questions')) { ?>
<div id="qnew" class="qblock">
	<form action="index.php" method="post">
		<input type="hidden" name="option" value="<?php echo $option; ?>" />
		<input type="hidden" name="controller" value="questions" />
		<input type="hidden" name="task" value="create" />
		<input type="hidden" name="data[category_id]" value="<?php echo $this->category->id; ?>" />
		<div class="contentheading"><?php echo $this->params->get('frontend_form_title'); ?></div>
		<div class="small"><?php echo $this->params->get('frontend_disclaimer'); ?></div>
		<textarea name="data[question]"></textarea>
		<input type="submit" value="Submit" />
		<input type="reset" value="Reset" />
	</form>
	<div><a href="#qlist"><?php echo JText::_('Back to Top'); ?></a></div>
</div>
<?php } ?>
