<?php
/**
* VirtueMart Categories Module
* NOTE: THIS MODULE REQUIRES THE PHPSHOP COMPONENT!
*
* @copyright (C) 2010 JFactory Project
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* This extention is Free Software.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

class VMTree extends JObject
{
	/**
	 * Root node
	 */
	var $root = null;

	/**
	 * Current working node
	 */
	var $current = null;

	/**
	 * Node/Id Hash for quickly handling node additions to the tree.
	 */
	var $nodes = array();

	function __construct()
	{
		$this->root = new VMNode(0, 'ROOT');
		$this->nodes[0] =& $this->root;
		$this->current =& $this->root;
	}

	function reset()
	{
		$this->current =& $this->root;
	}

	function addNode($item)
	{
		// Create the node and add it
		$node = new VMNode($item->id, $item->name, $item->image);

		$this->nodes[$item->id] =& $node;
		$this->current =& $this->nodes[$item->parent];
		$this->current->addChild($node);
	}

	function &getNode($id)
	{
		$result = null;
		if (isset($this->nodes[$id])) {
			$result = & $this->nodes[$id];
		}
		return $result;
	}

	function &getNodes()
	{
		return $this->nodes;
	}

	function &getCurrent()
	{
		return $this->current;
	}
}


/**
 * Tree Node Class.
 */
class VMNode extends JObject
{
	/**
	 * Parent node
	 */
	var $parent = null;

	/**
	 * Array of Children
	 */
	var $children = array();
	/**
	 * Node id
	 */
	var $id = null;
	/**
	 * Node name
	 */
	var $name = null;
	/**
	 * Node image
	 */
	var $image = null;

	function __construct($id, $name, $image = null)
	{
		$this->id		= $id;
		$this->name	= $name;
		$this->image	= $image;
	}

	function addChild( &$node )
	{
		$node->setParent($this);
		$this->children[] = & $node;
	}

	function &getParent()
	{
		return $this->parent;
	}

	function setParent( &$node )
	{
		$this->parent = & $node;
	}

	function hasChildren()
	{
		return count($this->children);
	}

	function &getChildren()
	{
		return $this->children;
	}

	function getPath(){
		if (!isset($this->path)) {
			$this->path = array();
			$this->path[0] = $this->id;
			$parent = $this->getParent();
			while($parent)
			{
				$this->path[] = $parent->id;
				$parent = $parent->getParent();
			}
		}
		return $this->path;
	}
}