<?php
/**
* VirtueMart Categories Module
* NOTE: THIS MODULE REQUIRES THE PHPSHOP COMPONENT!
*
* @copyright (C) 2010 JFactory Project
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* This extention is Free Software.
*/

// no direct access
defined('_JEXEC') or die( 'Restricted access' );

require_once (JPATH_SITE.DS.'modules'.DS.'mod_virtuemart_categories'.DS.'classes'.DS.'categories.php');

class JElementVirtuemartCategories extends JElement
{

	var $_name = 'VirtuemartCategories';

	function fetchElement($name, $value, &$node, $control_name)
	{
		$categories = & VirtuemartCategories::getInstance();
		$tree = & $categories->getTree();

		$options = JElementVirtuemartCategories::_toArray($tree);

		// array to hold tag attributes
		$attributes = array();
		$node->attributes('multiple') and ($attributes[] = 'multiple="multiple"');
		$node->attributes('size') and ($attributes[] = 'size="'.$node->attributes('size').'"');

		// for drop-down list add default option
		$node->attributes('multiple') or array_unshift($options, JHTML::_('select.option',  '', '- '.JText::_('Select Item').' -'));

		// empty select looks bad
		if (count($options))
			return JHtml::_('select.genericlist', $options, $control_name.'['.$name.'][]', implode(' ', $attributes), 'value', 'text', $value, $control_name.$name );
	}

	function _toArray(&$tree)
	{
		// set root node as current
		$tree->reset();
		$array = array();

		// recurse through children if they exist
		if ($tree->current->hasChildren())
		{
			foreach ($tree->current->getChildren() as $child)
			{
				$tree->current = & $child;
				JElementVirtuemartCategories::_getLevelItems($tree, 0 , $array);
			}
		}
		return $array;
	}

	function _getLevelItems(&$tree, $depth, &$array)
	{
		$depth++;

		// set item data
		$item = new StdClass();
		$item->value = $tree->current->id;
		$item->text =str_repeat('_',$depth-1).' |'.$depth.'| '.$tree->current->name;
		$array[] = $item;

		// recurse through item's children if they exist
		if ($tree->current->hasChildren())
		{
			foreach ($tree->current->getChildren() as $child)
			{
				$tree->current = & $child;
				JElementVirtuemartCategories::_getLevelItems($tree, $depth, $array);
			}
		}
	}
}