<?php
/**
* VirtueMart Categories Module
* NOTE: THIS MODULE REQUIRES THE PHPSHOP COMPONENT!
*
* @copyright (C) 2010 JFactory Project
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* This extention is Free Software.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'modules'.DS.'mod_virtuemart_categories'.DS.'classes'.DS.'categories.php');

jimport('joomla.utilities.simplexml');

/**
 * mod_vmcategories helper class
 *
 * @static
 * @package		VirtueMart
 * @subpackage	modules
 */
class modVMCategoriesHelper
{
	function &getXML(&$params)
	{
		$categories = & VirtuemartCategories::getInstance();
		$tree = & $categories->getTree();

		// convert categories tree to xml object
		$xml = modVMCategoriesHelper::toXML($tree, $params);

		return $xml->document;
	}

	function render(&$params,$decorator)
	{
		$xml = & modVMCategoriesHelper::getXML($params);
		$result = false;

		if ($xml) {
			// pass each node to $decorator function
			$xml->map($decorator, array('xml'=>$xml, 'params'=>$params));

			$class_sfx = $params->get('class_sfx');
			$tag_id = $params->get('tag_id');
			$xml->addAttribute('class', 'menu'.$class_sfx);
			$tag_id and $xml->addAttribute('id', $tag_id);

			echo JFilterOutput::ampReplace( $xml->toString(true) );

			$result = true;
		}

		return $result;
	}

	function toXML(&$tree, &$params)
	{
		// get JSimpleXML object
		$xml = JFactory::getXMLParser('Simple');
		$xml->document = new JSimpleXMLElement('ul');
		// set root
		$tree->current = & $tree->getNode($params->get('root_item', 0));

		// Recurse through children if they exist
		if ($tree->current->hasChildren())
		{
			foreach ($tree->current->getChildren() as $child)
			{
				$tree->current = & $child;
				modVMCategoriesHelper::_getLevelXML($tree, $params, 0, & $xml->document);
			}
		}
		if (!$xml->document->children()) {
			$xml->document = false;
		}
		return $xml;
	}

	function _getLevelXML(&$tree, &$params, $depth, &$parent_ul)
	{
		$depth ++;

		$categories = & VirtuemartCategories::getInstance();
		$active = & $categories->getActive();
		$path = isset($active) ? $active->getPath() : array();

		// filtering
		if ($filter_array = (array) $params->get('filter_list')) {
			switch ($params->get('filter_type'))
			{
				case 'BL': if (in_array($tree->current->id, $filter_array)) return; break;
				case 'WL': if (!in_array($tree->current->id, $filter_array)) return; break;
			}
		}

		// cut top levels off
		if ((int)$params->get('start_level') != 0 && (int)$params->get('start_level') >= $depth) {
			if ($tree->current->hasChildren() &&  in_array($tree->current->id, $path)) {
				foreach ($tree->current->getChildren() as $child)
				{
					$tree->current = & $child;
					modVMCategoriesHelper::_getLevelXML($tree, $params, $depth, $parent_ul);
				}
			}
			return;
		}

		$li = $parent_ul->addChild('li');

		// add attributes
		$li->addAttribute('level', $depth);
		$li->addAttribute('id', $tree->current->id);
		if ($tree->current->image) {
			$li->addAttribute('image', '/components/com_virtuemart/shop_image/category/'.$tree->current->image);
		}

		$a = $li->addChild('a');

		$menu_item = $params->get('menu_item',0);
		$link = 'index.php?option=com_virtuemart&page=shop.browse&category_id='.$tree->current->id.($menu_item ? '&Itemid='.$menu_item : '');

		$a->addAttribute('href', JRoute::_($link));
		$a->setData($tree->current->name);

		// cut deep levels off
		if (((int)$params->get('end_level') != 0 && (int)$params->get('end_level') <= $depth) ) {
			return;
		}

		// collapse tree
		if ($params->get('collapse') && !in_array($tree->current->id, $path) ) {
			return;
		}

		if ($tree->current->hasChildren()){
			$ul = $li->addChild('ul');
		}

		// Recurse through item's children if they exist
		if ($tree->current->hasChildren())
		{
			foreach ($tree->current->getChildren() as $child)
			{
				$tree->current = & $child;
				modVMCategoriesHelper::_getLevelXML($tree, $params, $depth, $ul);
			}
		}
			if (isset($ul) && !$ul->children()){
				$li->removeChild($ul);
			}

	}

}