<?php
/**
* VirtueMart Categories Module
* NOTE: THIS MODULE REQUIRES THE PHPSHOP COMPONENT!
*
* @copyright (C) 2010 JFactory Project
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* This extention is Free Software.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

if ( ! defined('VMCategoriesDecoratorDefined') )
{
	function VMCategoriesDecorator(&$node, &$args)
	{
		$categories = & VirtuemartCategories::getInstance();
		$active = $categories->getActive();
		$path = $active ? $active->getPath() : false;

		switch ($node->name())
		{
			case 'ul':
				// do nothing
				break;
			case 'li':
				if (!$node->attributes('id')) break;
				// set parent class
				if (isset($node->ul) && $node->ul) {
					$node->addAttribute('class', 'parent');
				}
				// set current class
				if ($path && $node->attributes('id') == $path[0]) {
					$node->addAttribute('class', $node->attributes('class').' current');
				}
				// set active class
				if ($path && in_array($node->attributes('id'), $path)) {
					$node->addAttribute('class', $node->attributes('class').' active');
				}
				break;
			case 'a':
				// do nothing
				break;
		}

		// remove xml attributes
		$node->removeAttribute('id');
		$node->removeAttribute('level');
		$node->removeAttribute('image');
	}

	define('VMCategoriesDecoratorDefined', true);
}

// output content of module, we pass module params and name of function, witch will get each xml-node
modVMCategoriesHelper::render($params, 'VMCategoriesDecorator');
