<?php
/**
* VirtueMart Categories Module
* NOTE: THIS MODULE REQUIRES THE PHPSHOP COMPONENT!
*
* @copyright (C) 2010 JFactory Project
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* This extention is Free Software.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

if ( ! defined('VMCategoriesMootreeDecoratorDefined') )
{
	function VMCategoriesMootreeDecorator(&$node, &$args)
	{
		$categories = & VirtuemartCategories::getInstance();
		$active = $categories->getActive();
		$path = $active ? $active->getPath() : false;

		switch ($node->name())
		{
			case 'ul':
				break;
			case 'li':
				// set parent class
				if (isset($node->ul) && $node->ul) {
					$node->addAttribute('class', 'parent');
				}
				// set current class
				if ($path && $node->attributes('id') == $path[0]) {
					$node->addAttribute('class', $node->attributes('class').' current');
				}
				// set active class
				if ($path && in_array($node->attributes('id'), $path)) {
					$node->addAttribute('class', $node->attributes('class').' active');
				}
				// add id for tree handling
				$node->addAttribute('id', $args['params']->get('tag_id').'_'.'item'.'_'.$node->attributes('id'));
				break;
			case 'a':
				break;
		}

		// remove xml attributes
		$node->removeAttribute('level');
		$node->removeAttribute('image');
	}

	define('VMCategoriesMootreeDecoratorDefined', true);
}

// tag id can't be empty
$params->get('tag_id') or $params->set('tag_id', 'mootree');

// render list
$rendered = modVMCategoriesHelper::render($params, 'VMCategoriesMootreeDecorator');

// if module isn't empty
if ($rendered){
	require JModuleHelper::getLayoutPath('mod_virtuemart_categories', 'mootree_assets');
}