<?php
/**
* VirtueMart Categories Module
* NOTE: THIS MODULE REQUIRES THE PHPSHOP COMPONENT!
*
* @copyright (C) 2010 JFactory Project
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* This extention is Free Software.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

//uri base
$uri_base = JURI::base();

// get categories
$categories = & VirtuemartCategories::getInstance();
// get categories tree
$tree = & $categories->getTree();
// get active node
$active = & $categories->getActive();
// get path of active item if exist
$path = isset($active) ? $active->getPath() : array();

// find root of menu
if ((int)$params->get('start_level')) {
	$path = array_reverse($path);
	// make start_level + level of root steps from top
	$level = $params->get('start_level') + count($tree->getNode($params->get('root_item', 0))->getPath());
	$root = $tree->getNode($path[$level -1]);
} else {
	$root = $tree->getNode($params->get('root_item', 0));
}

if (isset($root) && $root->id){
	// build link for root node
	$menu_item = $params->get('menu_item', 0);
	$link = 'index.php?option=com_virtuemart&page=shop.browse&category_id='.$root->id.($menu_item ? '&Itemid='.$menu_item : '');
} else {
	// build link for ultimate root
	$menu_item = $params->get('menu_item', 0);
	$menu = JSite::getMenu();
	$root = $menu->getItem($menu_item) ? $menu->getItem($menu_item) : $menu->getDefault();

	$router = JSite::getRouter();
	$link = $router->getMode() == JROUTER_MODE_SEF ? 'index.php?Itemid='.$root->id : $root->link.'&Itemid='.$root->id;
}

$root_text = addslashes($root->name);
$root_url =  str_replace( '&amp;', '&', JRoute::_($link) );

$script = "
window.addEvent('domready', function(){
	tree = new MooTreeControl({
		div: new Element('div').injectBefore($('{$params->get('tag_id')}')),
		mode: 'folders',
		grid: true,
		theme: '{$uri_base}media/system/images/mootree.gif',
		onClick: function(node){ location.href = node.data.url; }
	},{
		text: '{$root_text}',
		open: true,
		data: {url: '{$root_url}'}
	});

	activeItems = [];
	currentItem = '';
	$('{$params->get('tag_id')}').getElements('.active').each(function(element){
		activeItems.push(element.id);
		if (element.hasClass('current')) currentItem = element.id;
	});

	tree.adopt('{$params->get('tag_id')}');

	if (currentItem) {
		tree.select(tree.get('node_'+currentItem), true);
	}
	activeItems.each(function(item, index){
		tree.get('node_'+activeItems[index]).toggle(false, true);
	});

});
";

JHTML::script('mootree.js');
JHTML::stylesheet('mootree.css');

// get document
$document =& JFactory::getDocument();
$document->addScriptDeclaration($script);
