<?php
/**
* VirtueMart Categories Module
* NOTE: THIS MODULE REQUIRES THE PHPSHOP COMPONENT!
*
* @copyright (C) 2010 JFactory Project
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* This extention is Free Software.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

if ( ! defined('VMCategoriesSelectDecoratorDefined') )
{
	function VMCategoriesSelectDecorator(&$node, &$args)
	{
		$categories = & VirtuemartCategories::getInstance();
		$active = $categories->getActive();
		$path = $active ? $active->getPath() : false;

		switch ($node->name())
		{
			case 'ul':
				// do nothing
				break;
			case 'li':
				// nest option at the end of list and empty li
				$option = $args['xml']->addChild('option');
				$data = str_repeat('=',$node->attributes('level')-1).'=>'.$node->getElementByPath('a')->data();
				$option->setData($data);
				$option->addAttribute('value', $node->getElementByPath('a')->attributes('href'));
				$node->removeChild($node->getElementByPath('a'));

				// set parent class
				if (isset($node->ul) && $node->ul) {
					$option->addAttribute('class', 'parent');
				}
				// set current class
				if ($path && $node->attributes('id') == $path[0]) {
					$option->addAttribute('class', $option->attributes('class').' current');
					$option->addAttribute('selected', 'selected');
				}
				// set active class
				if ($path && in_array($node->attributes('id'), $path)) {
					$option->addAttribute('class', $option->attributes('class').' active');
				}
				break;
			case 'a':
				// do nothing
				break;
		}

		// remove xml attributes
		$node->removeAttribute('id');
		$node->removeAttribute('level');
		$node->removeAttribute('image');
	}

	define('VMCategoriesSelectDecoratorDefined', true);
}

// get xml directly coz we have to make some manipulations with it
$xml = & modVMCategoriesHelper::getXML($params);

if ($xml) {
	// pass each node to $decorator function
	$xml->map('VMCategoriesSelectDecorator', array('xml'=>$xml, 'params'=>$params));

	$class_sfx = $params->get('class_sfx');
	$tag_id = $params->get('tag_id');
	$trigger = 'location = this.value';

	$xml->addAttribute('class', 'select'.$class_sfx);
	$tag_id and $xml->addAttribute('id', $tag_id);
	$xml->addAttribute('onchange', $trigger);

	// replace ul tag name with select using JObject method
	$xml->set('_name', 'select');

	// remove li's
	foreach ($xml->children() as $child)
	{
		if ($child->name() == 'li') {
			$xml->removeChild($child);
		}
	}

	echo JFilterOutput::ampReplace( $xml->toString(true) );
}
